/* AMX Mod X
*   HL WeaponBox Models
*
* (c) Copyright 2007 by VEN
*
* This file is provided as is (no warranties)
*/

// plugin's main information
#define PLUGIN_NAME "HL WeaponBox Models"
#define PLUGIN_VERSION "0.1"
#define PLUGIN_AUTHOR "VEN"

#include <amxmodx>
#include <fakemeta>

new const g_weaponbox[] = "weaponbox"

new const g_weaponbox_models[][] = {
	"models/w_weaponbox.mdl",  // WEAPON_NONE
	"models/w_crowbar.mdl",    // WEAPON_CROWBAR
	"models/w_9mmhandgun.mdl", // WEAPON_GLOCK       AKA weapon_9mmhandgun
	"models/w_357.mdl",        // WEAPON_PYTHON      AKA weapon_357
	"models/w_9mmAR.mdl",      // WEAPON_MP5         AKA weapon_9mmAR
	"models/w_weaponbox.mdl",  // WEAPON_CHAINGUN    [nonexistent]
	"models/w_crossbow.mdl",   // WEAPON_CROSSBOW
	"models/w_shotgun.mdl",    // WEAPON_SHOTGUN
	"models/w_rpg.mdl",        // WEAPON_RPG
	"models/w_gauss.mdl",      // WEAPON_GAUSS
	"models/w_egon.mdl",       // WEAPON_EGON
	"models/w_hgun.mdl",       // WEAPON_HORNETGUN
	"models/w_grenade.mdl",    // WEAPON_HANDGRENADE
	"models/v_tripmine.mdl",   // WEAPON_TRIPMINE
	"models/w_satchel.mdl",    // WEAPON_SATCHEL
	"models/w_sqknest.mdl"     // WEAPON_SNARK
}

#define WEAPONTYPE_MIN HLW_CROWBAR
#define WEAPONTYPE_MAX HLW_SNARK

new g_max_clients

public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)
	register_forward(FM_SetModel, "forward_set_model")
	g_max_clients = global_get(glb_maxClients)
}

public forward_set_model(ent) {
	if (!pev_valid(ent))
		return FMRES_IGNORED

	static classname[32]
	pev(ent, pev_classname, classname, sizeof classname - 1)
	if (!equal(classname, g_weaponbox))
		return FMRES_IGNORED

	static id
	if (!(1 <= (id = pev(ent, pev_owner)) <= g_max_clients))
		return FMRES_IGNORED

	static weapontype
	if (!(WEAPONTYPE_MIN <= (weapontype = get_user_weapon(id, weapontype, weapontype)) <= WEAPONTYPE_MAX))
		return FMRES_IGNORED

	engfunc(EngFunc_SetModel, ent, g_weaponbox_models[weapontype])

	return FMRES_SUPERCEDE
}
